#-*-coding:utf8-*-

from common.fromAll_snappy  import *

class freepanelAdvancedClass:

    def __init__(self, mainself):
    
        self.caseDir = mainself.caseDir
        self.mainwindow = mainself.window
        self.installpath = mainself.installpath
        self.gvtk = mainself.gvtk
        self.notebook = mainself.notebook
        self.discombo = mainself.discombo
        
        self.root = mainself.root
        self.tree = mainself.tree
        self.adv = self.root.find('advanced')

        self.GEN = generalClass(mainself)
        
        self.pixbuf_main = mainself.pixbuf_main
        self.pixbuf_first = mainself.pixbuf_first
        self.pixbuf_second = mainself.pixbuf_second

    def advanced(self):

        self.advbox = gtk.VBox()          
        
        swin = gtk.ScrolledWindow()
        swin.set_border_width(0)
        swin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        swin.set_size_request(400, -1)
        
        self.advbox.pack_start(swin, True, True, 0)
        
        ebox = gtk.EventBox()
        ebox.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('white'))
        swin.add_with_viewport(ebox)
        self.mainbox = gtk.VBox(False, 0)
        ebox.add(self.mainbox)
        #-------------------------------------------------------------------------------------       
        self.treestore = gtk.TreeStore(gtk.gdk.Pixbuf, str, str)
        
        self.treeview = gtk.TreeView(self.treestore)
        
        self.treeview.set_headers_visible(False)
        self.treeview.set_enable_tree_lines(True)
                
        self.tvcolumn0 = gtk.TreeViewColumn(None)
        self.tvcolumn1 = gtk.TreeViewColumn(None)
        
        self.treeview.append_column(self.tvcolumn0)
        self.treeview.append_column(self.tvcolumn1)

        self.renbuf = gtk.CellRendererPixbuf()
        self.ren0 = gtk.CellRendererText()
        self.ren1 = gtk.CellRendererText() 

        self.ren0.set_property('editable', False)
        self.ren1.set_property('editable', True)
        
        self.ren0.set_fixed_size(170, -1) 
        
        self.tvcolumn0.pack_start(self.renbuf, False)
        self.tvcolumn0.pack_start(self.ren0, False) 
        self.tvcolumn1.pack_start(self.ren1, False)
        
        self.tvcolumn0.set_attributes(self.renbuf, pixbuf = 0)
        self.tvcolumn0.set_attributes(self.ren0, text = 1)  
        
        self.ren1.connect('edited', self.changeValue)        
        self.tvcolumn1.set_cell_data_func(self.ren1, self.func)
        
        self.makeTreeStore()        
        self.mainbox.add(self.treeview)             

        return self.advbox
    #---------------------------------------------------------------------------------------------------------        
    def makeTreeStore(self):
    
        self.treestore.clear()
        
        row_main = self.treestore.append(None, [self.pixbuf_main, 'Advanced options', None])
       
        self.treestore.append(row_main, [self.pixbuf_first, 'maxNonOrtho', None])
        self.treestore.append(row_main, [self.pixbuf_first, 'maxBoundarySkewness', None])
        self.treestore.append(row_main, [self.pixbuf_first, 'maxInternalSkewness', None])
        self.treestore.append(row_main, [self.pixbuf_first, 'maxConcave', None])
        self.treestore.append(row_main, [self.pixbuf_first, 'minVol', None])
        self.treestore.append(row_main, [self.pixbuf_first, 'minTetQuality', None])
        self.treestore.append(row_main, [self.pixbuf_first, 'minArea', None])
        self.treestore.append(row_main, [self.pixbuf_first, 'minTwist', None])
        self.treestore.append(row_main, [self.pixbuf_first, 'minDeterminant', None])
        self.treestore.append(row_main, [self.pixbuf_first, 'minFaceWeight', None])
        self.treestore.append(row_main, [self.pixbuf_first, 'minVolRatio', None])
        self.treestore.append(row_main, [self.pixbuf_first, 'minTriangleTwist', None])
        self.treestore.append(row_main, [self.pixbuf_first, 'nSmoothScale', None])
        self.treestore.append(row_main, [self.pixbuf_first, 'errorReduction', None])
        self.treestore.append(row_main, [self.pixbuf_first, 'relaxedMaxNonOrtho', None])
        self.treestore.append(row_main, [self.pixbuf_first, 'mergeTolerance', None])
        
        self.treeview.expand_all()         
    #---------------------------------------------------------------------------------------------    
    def func(self, column, cell, model, iter):

        value0 = model.get_value(iter, 1)
        path = model.get_path(iter)
        
        entryList = ['nSmoothPatch', 'tolerance', 'nSolveIter', 'nRelaxIter', 'nFeatureSnapIter']
        checkList = ['implicitFeatureSnap', 'explicitFeatureSnap', 'multiRegionFeatureSnap']       
        
        if value0 == 'Advanced options':
            self.ren1.set_property('visible' ,0)
        else:
            self.ren1.set_property('visible', 1)            
            self.ren1.set_property('text', self.adv.find(value0).text)                      
    #---------------------------------------------------------------------------------------------------------        
    def changeValue(self, widget, path, what):
    
        treeiter = self.treestore.get_iter(path)
        value0 = self.treestore.get_value(treeiter, 1)        

        if self.GEN.checkNumber(value0, what):
            self.adv.find(value0).text = what

        generalClass(self).indentXML(self.root) 
        self.tree.write(self.caseDir + '/setup_snappy.xml')   


                                    

