#-*-coding:utf8-*-

from common.fromAll_snappy  import *

class freepanelBlockMeshClass:

    def __init__(self, mainself):
        
        self.caseDir = mainself.caseDir
        self.mainwindow = mainself.window
        self.installpath = mainself.installpath
        self.renderer = mainself.renderer
        self.VTK_All = VTKStuff(mainself.caseDir)
        self.gvtk = mainself.gvtk
        self.notebook = mainself.notebook
        self.discombo = mainself.discombo
        self.Actors = mainself.Actors
        
        self.root = mainself.root
        self.tree = mainself.tree    
        self.mainself = mainself
            
        self.block = self.root.find('blockMesh')

        self.GEN = generalClass(mainself)
        
        self.pixbuf_main = mainself.pixbuf_main
        self.pixbuf_first = mainself.pixbuf_first
        self.pixbuf_second = mainself.pixbuf_second

        self.farActor = []       
                                
    def blockMesh(self):

        self.blockMeshbox = gtk.VBox()          
        
        swin = gtk.ScrolledWindow()
        swin.set_border_width(0)
        swin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        swin.set_size_request(400, -1)
        
        self.underbox = gtk.VBox(False, 0)
        self.blockMeshbox.pack_start(swin, True, True, 0)
        self.blockMeshbox.pack_end(self.underbox, False, False, 0)
        
        ebox = gtk.EventBox()
        ebox.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('white'))
        swin.add_with_viewport(ebox)
        self.mainbox = gtk.VBox(False, 0)
        ebox.add(self.mainbox)
        #-------------------------------------------------------------------------------------       
        self.treestore = gtk.TreeStore(gtk.gdk.Pixbuf, str, str, str, str)
        
        self.treeview = gtk.TreeView(self.treestore)
        
        self.treeview.set_headers_visible(False)
        self.treeview.set_enable_tree_lines(True)
                
        self.tvcolumn0 = gtk.TreeViewColumn(None)
        self.tvcolumn1 = gtk.TreeViewColumn(None)
        
        self.treeview.append_column(self.tvcolumn0)
        self.treeview.append_column(self.tvcolumn1)

        self.renbuf = gtk.CellRendererPixbuf()
        self.ren0 = gtk.CellRendererText()
        self.ren1_0 = gtk.CellRendererText()
        self.ren1_1 = gtk.CellRendererText()
        self.ren1_2 = gtk.CellRendererText()

        self.ren1_0.set_fixed_size(40, -1)
        self.ren1_1.set_fixed_size(40, -1)
        self.ren1_2.set_fixed_size(40, -1)
        
        self.ren1_0.set_property("editable", True)
        self.ren1_1.set_property("editable", True)
        self.ren1_2.set_property("editable", True)
        
        self.ren1_0.connect('edited', self.changeValue, 'x')
        self.ren1_1.connect('edited', self.changeValue, 'y')
        self.ren1_2.connect('edited', self.changeValue, 'z')
        
        self.tvcolumn0.pack_start(self.renbuf, False)
        self.tvcolumn0.pack_start(self.ren0, False)
        self.tvcolumn0.set_attributes(self.renbuf, pixbuf = 0)
        self.tvcolumn0.set_attributes(self.ren0, text = 1)        
        
        self.tvcolumn1.pack_start(self.ren1_0, True)
        self.tvcolumn1.pack_start(self.ren1_1, True) 
        self.tvcolumn1.pack_start(self.ren1_2, True)
        self.tvcolumn1.set_cell_data_func(self.ren1_0, self.func)

        self.makeTreeStore()
        self.mainbox.add(self.treeview)             
        
        # button     
        self.rangeB = gtk.Button('Set domain range')
        self.rangeB.set_size_request(150, 28)
        self.rangeB.connect('clicked', self.setDomainRange)
        
        self.blockB = gtk.Button('blockMesh')
        self.blockB.set_size_request(150, 28)
        self.blockB.connect('clicked', self.runBlockMesh)
        
        hbox = gtk.HBox(False, 0)
        self.underbox.pack_start(hbox, False, False, 0)
        hbox.pack_start(self.rangeB, True, True, 0)
        hbox.pack_end(self.blockB, True, True, 0)
        
        self.createFarSurface()

        return self.blockMeshbox
    #--------------------------------------------------------------------------------------------------------- 
    def makeTreeStore(self):
    
        self.treestore.clear()
        row_main = self.treestore.append(None, [self.pixbuf_main, 'blockMesh', None, None, None])
        row_domain = self.treestore.append(row_main, [self.pixbuf_first, 'Domain size', None, None, None])         
        self.treestore.append(row_domain, [self.pixbuf_second, 'min. x y z', None, None, None]) 
        self.treestore.append(row_domain, [self.pixbuf_second, 'max. x y z', None, None, None]) 

        row_size = self.treestore.append(row_main, [self.pixbuf_first, 'Mesh size', None, None, None])
        self.treestore.append(row_size, [self.pixbuf_second, 'No. x y z', None, None, None])
        
        self.treeview.expand_all()        
    #--------------------------------------------------------------------------------------------------------- 
    def func(self, column, cell, model, iter):
    
        value0 = model.get_value(iter, 1)
        path = model.get_path(iter)
        
        if value0 == 'Domain size' or value0 == 'Mesh size' or value0 == 'blockMesh':
            self.ren1_0.set_property('visible', 0) 
            self.ren1_1.set_property('visible', 0) 
            self.ren1_2.set_property('visible', 0)            
        else:
            self.ren1_0.set_property('visible', 1)
            self.ren1_1.set_property('visible', 1)
            self.ren1_2.set_property('visible', 1)
            if value0 == 'min. x y z':
                self.ren1_0.set_property('text', self.block.find('minx').text)
                self.ren1_1.set_property('text', self.block.find('miny').text)
                self.ren1_2.set_property('text', self.block.find('minz').text) 
            elif value0 == 'max. x y z':
                self.ren1_0.set_property('text', self.block.find('maxx').text)
                self.ren1_1.set_property('text', self.block.find('maxy').text)
                self.ren1_2.set_property('text', self.block.find('maxz').text) 
            elif value0 == 'No. x y z':
                self.ren1_0.set_property('text', self.block.find('nx').text)
                self.ren1_1.set_property('text', self.block.find('ny').text)
                self.ren1_2.set_property('text', self.block.find('nz').text) 
    #---------------------------------------------------------------------------------------------------------        
    def changeValue(self, widget, path, what, xyz):
    
        treeiter = self.treestore.get_iter(path)
        value0 = self.treestore.get_value(treeiter, 1)      

        if value0 == 'min. x y z':
            if xyz == 'x':
                self.block.find('minx').text = what
            elif xyz == 'y':
                self.block.find('miny').text = what
            elif xyz == 'z':
                self.block.find('minz').text = what        
        elif value0 == 'max. x y z':
            if xyz == 'x':
                self.block.find('maxx').text = what
            elif xyz == 'y':
                self.block.find('maxy').text = what
            elif xyz == 'z':
                self.block.find('maxz').text = what
        elif value0 == 'No. x y z':
            if xyz == 'x':
                self.block.find('nx').text = what
            elif xyz == 'y':
                self.block.find('ny').text = what
            elif xyz == 'z':
                self.block.find('nz').text = what
            
        generalClass(self).indentXML(self.root) 
        self.tree.write(self.caseDir + '/setup_snappy.xml')
        
        self.createFarSurface()
    #-------------------------------------------------------------------------------------------------
    def runBlockMesh(self, widget):
        
        self.makeBlockMeshDict()
        if os.path.isdir(self.caseDir + '/constant/polyMesh'):
            os.system('rm -r ' + self.caseDir + '/constant/polyMesh')
        
        os.system('blockMesh -case ' + self.caseDir + ' > /dev/pts/' + self.mainself.termTTY)
        
        self.displayBlockMesh()
        self.notebook.set_current_page(0)
        self.gvtk.Initialize()              
    #-------------------------------------------------------------------------------------------------    
    def displayBlockMesh(self):
    
        while True:
            aa = glob.glob(self.caseDir + '/constant/polyMesh/boundary')
            if aa:
                break
            time.sleep(1)

        self.renderer.RemoveAllViewProps()
        for ii in self.Actors:
            self.renderer.AddActor(ii)

        self.blockActor = self.VTK_All.blockMeshNew()
        self.renderer.AddActor(self.blockActor)
        self.gvtk.Initialize()              
    #-------------------------------------------------------------------------------------------------        
    def setDomainRange(self, widget):
    
        stls = glob.glob(self.caseDir + '/constant/triSurface/*.stl')

        xranges = []
        yranges = []
        zranges = []
        for ii in stls:
            rangelist = self.GEN.getSTLRange(ii)
            xranges.append(rangelist[0][0])
            xranges.append(rangelist[1][0])
            yranges.append(rangelist[0][1])
            yranges.append(rangelist[1][1])
            zranges.append(rangelist[0][2])
            zranges.append(rangelist[1][2])
            
        minx = min(xranges)
        miny = min(yranges)
        minz = min(zranges)
        maxx = max(xranges)
        maxy = max(yranges)
        maxz = max(zranges)           

        dx = float(maxx) - float(minx)
        dy = float(maxy) - float(miny)
        dz = float(maxz) - float(minz)            
        minix = float(minx) - dx * 0.01
        miniy = float(miny) - dy * 0.01
        miniz = float(minz) - dz * 0.01
        maxix = float(maxx) + dx * 0.01
        maxiy = float(maxy) + dy * 0.01
        maxiz = float(maxz) + dz * 0.01
            
        self.block.find('minx').text = '%0.4f'%minix
        self.block.find('miny').text = '%0.4f'%miniy
        self.block.find('minz').text = '%0.4f'%miniz
        self.block.find('maxx').text = '%0.4f'%maxix
        self.block.find('maxy').text = '%0.4f'%maxiy
        self.block.find('maxz').text = '%0.4f'%maxiz
        
        self.makeTreeStore()
        
        self.createFarSurface()
    #-------------------------------------------------------------------------------------------------
    def makeBlockMeshDict(self):
    
        aa = glob.glob(self.caseDir + '/system')
        if aa == []:
            os.system('mkdir ' + self.caseDir + '/system')
        
        minx = self.block.find('minx').text
        miny = self.block.find('miny').text
        minz = self.block.find('minz').text
        maxx = self.block.find('maxx').text
        maxy = self.block.find('maxy').text
        maxz = self.block.find('maxz').text        
        nx = self.block.find('nx').text
        ny = self.block.find('ny').text
        nz = self.block.find('nz').text
                
        f = open(self.caseDir + '/system/blockMeshDict', 'w')
        
        f.write('/*--------------------------------*- C++ -*----------------------------------*\ \n')
        f.write('| =========                 |                                                 | \n')
        f.write('| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           | \n')
        f.write('|  \\    /   O peration     | Version:  2.2.0                                 | \n')
        f.write('|   \\  /    A nd           | Web:      www.OpenFOAM.org                      | \n')
        f.write('|    \\/     M anipulation  |                                                 | \n')
        f.write('\*---------------------------------------------------------------------------*/ \n')
        f.write('FoamFile \n')
        f.write('{ \n')
        f.write('    version     2.0; \n')
        f.write('    format      ascii; \n')
        f.write('    class       dictionary; \n')
        f.write('    object      blockMeshDict; \n')
        f.write('} \n')
        f.write('// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * // \n')

        f.write('convertToMeters 1; \n')
        f.write('vertices \n')
        f.write('( \n')
        f.write('   ( ' + minx + ' ' + miny + ' ' + minz + ' ) \n') 
        f.write('   ( ' + maxx + ' ' + miny + ' ' + minz + ' ) \n')         
        f.write('   ( ' + maxx + ' ' + maxy + ' ' + minz + ' ) \n')         
        f.write('   ( ' + minx + ' ' + maxy + ' ' + minz + ' ) \n')         
        f.write('   ( ' + minx + ' ' + miny + ' ' + maxz + ' ) \n')         
        f.write('   ( ' + maxx + ' ' + miny + ' ' + maxz + ' ) \n') 
        f.write('   ( ' + maxx + ' ' + maxy + ' ' + maxz + ' ) \n') 
        f.write('   ( ' + minx + ' ' + maxy + ' ' + maxz + ' ) \n') 
        f.write(');\n')
        f.write('blocks\n')
        f.write('(\n')
        f.write('    hex (0 1 2 3 4 5 6 7) (' + nx + ' ' + ny + ' ' + nz + ') simpleGrading (1 1 1)\n')
        f.write(');\n')
        f.write('edges\n')
        f.write('(\n')
        f.write(');\n')
        f.write('boundary\n')
        f.write('(\n')
        
        f.write('    minX \n')
        f.write('    { \n')
        f.write('        type patch; \n')
        f.write('        faces \n')
        f.write('        ( \n')
        f.write('            (0 3 7 4) \n')
        f.write('        ); \n')
        f.write('    } \n')

        f.write('    maxX \n')
        f.write('    { \n')
        f.write('        type patch; \n')
        f.write('        faces \n')
        f.write('        ( \n')
        f.write('            (1 2 6 5) \n')
        f.write('        ); \n')
        f.write('    } \n')

        f.write('    minY \n')
        f.write('    { \n')
        f.write('        type patch; \n')
        f.write('        faces \n')
        f.write('        ( \n')
        f.write('            (0 1 5 4) \n')
        f.write('        ); \n')
        f.write('    } \n')

        f.write('    maxY \n')
        f.write('    { \n')
        f.write('        type patch; \n')
        f.write('        faces \n')
        f.write('        ( \n')
        f.write('            (3 7 6 2) \n')
        f.write('        ); \n')
        f.write('    } \n')

        f.write('    minZ \n')
        f.write('    { \n')
        f.write('        type patch; \n')
        f.write('        faces \n')
        f.write('        ( \n')
        f.write('            (0 1 2 3) \n')
        f.write('        ); \n')
        f.write('    } \n')

        f.write('    maxZ \n')
        f.write('    { \n')
        f.write('        type patch; \n')
        f.write('        faces \n')
        f.write('        ( \n')
        f.write('            (4 5 6 7) \n')
        f.write('        ); \n')
        f.write('    } \n')
        
        f.write('); \n')
           
        f.close() 
    #---------------------------------------------------------------------------------------------------------         
    def createFarSurface(self):
    
        if self.farActor:
            for ii in self.farActor:
                self.renderer.RemoveActor(ii)
        
        minx = self.block.find('minx').text
        miny = self.block.find('miny').text
        minz = self.block.find('minz').text
        maxx = self.block.find('maxx').text
        maxy = self.block.find('maxy').text
        maxz = self.block.find('maxz').text

        delx = float(maxx) - float(minx)
        dely = float(maxy) - float(miny)
        delz = float(maxz) - float(minz)
            
        unit = self.installpath + '/common/unitbox.stl'
                
        self.GEN.submitFile("surfaceTransformPoints -scale '(" + str(delx) + " " + str(dely) + " " + str(delz) + ")' " \
                + unit + " " + self.caseDir + '/scaledbox.stl > /dev/null 2>&1')
                
        self.GEN.submitFile("surfaceTransformPoints -translate '(" + minx + " " + miny + " " + minz + ")' " \
                + self.caseDir + "/scaledbox.stl" + " " + self.caseDir + '/system/settings/block.stl > /dev/null 2>&1')
                        
        #self.GEN.stlSplitRegions(self.caseDir + '/system/settings/block.stl')
        self.stlSplitRegions(self.caseDir + '/system/settings/block.stl')
        fars = [self.caseDir + '/system/settings/minx.stl', self.caseDir + '/system/settings/maxx.stl',
                self.caseDir + '/system/settings/miny.stl', self.caseDir + '/system/settings/maxy.stl',
                self.caseDir + '/system/settings/minz.stl', self.caseDir + '/system/settings/maxz.stl']
                        
        self.farActor = self.VTK_All.showSTLMulti(fars)
                
        for ii in self.farActor:
            self.renderer.AddActor(ii)
        
        self.renderer.ResetCamera()
        self.gvtk.Initialize()                                    
    #-----------------------------------------------------------------------------------------------------
    def stlSplitRegions(self, filename):
        
        with open(filename, 'r') as f:
            ff = f.readlines()
        regionnames = []
        startlines = []
        for i in range(len(ff)):
            if ff[i][:5].lower() == 'solid':
                a0 = ff[i].strip()
                a1 = a0.split()
                regionnames.append(a1[1])
                startlines.append(i+1)

        nlines = []
        for k in range(len(regionnames) - 1):
            cc = int(startlines[k+1]) - int(startlines[k])
            nlines.append(cc)
        nlines.append(len(ff) - int(startlines[-1]) + 1)
                                
        for j in range(len(regionnames)):
            g = open(self.caseDir + '/system/settings/' + regionnames[j] + '.stl', 'w')
            for ii in range(nlines[j]):
                jj = startlines[j] -1 + ii
                g.write(ff[jj])
            g.flush()            
            g.close()            
            #time.sleep(0.5)
