#-*-coding:utf8-*-

from common.fromAll_snappy  import *

class freepanelCastellateClass:

    def __init__(self, mainself):
        self.caseDir = mainself.caseDir
        self.window = mainself.window
        self.installpath = mainself.installpath
        self.renderer = mainself.renderer
        self.VTK_All = VTKStuff(mainself.caseDir)
        
        self.gvtk = mainself.gvtk
        self.notebook = mainself.notebook
        self.discombo = mainself.discombo
        self.Actors = mainself.Actors
        
        self.root = mainself.root
        self.tree = mainself.tree
        self.stlnames = mainself.stlnames
        
        self.castel = mainself.castel
        self.box = mainself.box
        self.surfaceLevel = mainself.surfaceLevel
        self.featureLevel = mainself.featureLevel
        self.boxLevel = mainself.boxLevel

        self.GEN = generalClass(mainself)
        
        self.pixbuf_main = mainself.pixbuf_main
        self.pixbuf_first = mainself.pixbuf_first
        self.pixbuf_second = mainself.pixbuf_second
        
        self.boxActorDict = mainself.boxActorDict
        self.coneActor = None
        
    def castellate(self):

        self.castellbox = gtk.VBox()          
        
        swin = gtk.ScrolledWindow()
        swin.set_border_width(0)
        swin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        swin.set_size_request(400, -1)
        
        self.underbox = gtk.VBox(False, 0)
        self.castellbox.pack_start(swin, True, True, 0)
        self.castellbox.pack_end(self.underbox, False, False, 0)
        
        ebox = gtk.EventBox()
        ebox.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('white'))
        swin.add_with_viewport(ebox)
        self.mainbox = gtk.VBox(False, 0)
        ebox.add(self.mainbox)
        #-------------------------------------------------------------------------------------       
        self.treestore = gtk.TreeStore(gtk.gdk.Pixbuf, str, bool, str, str, str)
        
        self.treeview = gtk.TreeView(self.treestore)
        
        self.treeview.set_headers_visible(False)
        self.treeview.set_enable_tree_lines(True)
        
        self.treeview.connect('cursor-changed', self.selected, self.treeview)
                
        self.tvcolumn0 = gtk.TreeViewColumn(None)
        self.tvcolumn1 = gtk.TreeViewColumn(None)
        
        self.treeview.append_column(self.tvcolumn0)
        self.treeview.append_column(self.tvcolumn1)

        self.renbuf = gtk.CellRendererPixbuf()
        self.ren0 = gtk.CellRendererText()
        self.renToggle = gtk.CellRendererToggle()
        self.ren1_0 = gtk.CellRendererText()
        self.ren1_1 = gtk.CellRendererText()
        self.ren1_2 = gtk.CellRendererText()

        self.ren1_0.set_fixed_size(60, -1)
        self.ren1_1.set_fixed_size(60, -1)
        self.ren1_2.set_fixed_size(60, -1)
        
        self.renToggle.set_property('activatable', True)
        self.ren1_0.set_property("editable", True)
        self.ren1_1.set_property("editable", True)
        self.ren1_2.set_property("editable", True)
        
        self.renToggle.connect('toggled',self.toggleRen, self.treestore)
        self.ren1_0.connect('edited', self.changeValue, 'x')
        self.ren1_1.connect('edited', self.changeValue, 'y')
        self.ren1_2.connect('edited', self.changeValue, 'z')
        
        self.tvcolumn0.pack_start(self.renbuf, False)
        self.tvcolumn0.pack_start(self.ren0, False)
        self.tvcolumn0.set_attributes(self.renbuf, pixbuf = 0)
        self.tvcolumn0.set_attributes(self.ren0, text = 1)               

        self.tvcolumn1.pack_start(self.renToggle, False)
        self.tvcolumn1.add_attribute(self.renToggle, 'active', 2)
        
        self.tvcolumn1.pack_start(self.ren1_0, True)
        self.tvcolumn1.pack_start(self.ren1_1, True) 
        self.tvcolumn1.pack_start(self.ren1_2, True)
        self.tvcolumn1.set_cell_data_func(self.ren1_0, self.func)

        self.makeTreeStore()
        self.mainbox.add(self.treeview)             
        
        # button     
        self.pointB = gtk.Button('Display point')
        self.pointB.set_size_request(150, 28)
        self.pointB.connect('clicked', self.showPoint)
        
        self.calB = gtk.Button('Size level calculator')
        self.calB.set_size_request(150, 28)
        self.calB.connect('clicked', self.sizeLevelCalculator)
        
        hbox = gtk.HBox(False, 0)
        self.underbox.pack_start(hbox, False, False, 0)
        hbox.pack_start(self.pointB, True, True, 0)
        hbox.pack_end(self.calB, True, True, 0)

        return self.castellbox        
    #--------------------------------------------------------------------------------------------------------- 
    def makeTreeStore(self):
    
        self.treestore.clear()
                
        row_main = self.treestore.append(None, [self.pixbuf_main, 'Castellate mesh', None, None, None, None])
        row_loc = self.treestore.append(row_main, [self.pixbuf_first, 'Location in mesh', None, None, None, None])
        row_size = self.treestore.append(row_main, [self.pixbuf_first, 'Surface/Feature size', None, None, None, None])         
        if len(self.box) != 0:
            row_box = self.treestore.append(row_main, [self.pixbuf_first, 'Searchable box size', None, None, None, None])         
        row_opt = self.treestore.append(row_main, [self.pixbuf_first, 'options', None, None, None, None])         

        self.treestore.append(row_loc, [self.pixbuf_second, 'x y z coord.', None, None, None, None]) 

        for ii in self.stlnames:
            self.treestore.append(row_size, [self.pixbuf_second, ii, None, None, None, None]) 
        for ii in self.box:
            self.treestore.append(row_box, [self.pixbuf_second, ii.tag, None, None, None, None]) 
        
        self.treestore.append(row_opt, [self.pixbuf_second, 'maxLocalCells', None, None, None, None]) 
        self.treestore.append(row_opt, [self.pixbuf_second, 'maxGlobalCells', None, None, None, None]) 
        self.treestore.append(row_opt, [self.pixbuf_second, 'minRefinementCells', None, None, None, None]) 
        self.treestore.append(row_opt, [self.pixbuf_second, 'maxLoadUnbalance', None, None, None, None]) 
        self.treestore.append(row_opt, [self.pixbuf_second, 'nCellsBetweenLevels', None, None, None, None]) 
        self.treestore.append(row_opt, [self.pixbuf_second, 'resolveFeatureAngle', None, None, None, None]) 
        
        if self.castel.find('allowFreeStanding').text == 'yes':
            self.treestore.append(row_opt, [self.pixbuf_second, 'freeStandingZoneFaces', True, None, None, None])
        else:
            self.treestore.append(row_opt, [self.pixbuf_second, 'freeStandingZoneFaces', False, None, None, None])
        
        self.treeview.expand_all()         
    #--------------------------------------------------------------------------------------------------------- 
    def func(self, column, cell, model, iter):
    
        value0 = model.get_value(iter, 1)
        path = model.get_path(iter)
        
        nones = ['Castellate mesh', 'Location in mesh', 'Surface/Feature size', 'Searchable box size', 'options']
        entrys = ['maxLocalCells', 'maxGlobalCells', 'minRefinementCells', 'maxLoadUnbalance', 'nCellsBetweenLevels', 'resolveFeatureAngle'] 
        
        if value0 in nones:
            self.renToggle.set_property('visible', 0)
            self.ren1_0.set_property('visible', 0) 
            self.ren1_1.set_property('visible', 0) 
            self.ren1_2.set_property('visible', 0)            
        elif value0 == 'x y z coord.':
            self.renToggle.set_property('visible', 0)
            self.ren1_0.set_property('visible', 1)
            self.ren1_1.set_property('visible', 1)
            self.ren1_2.set_property('visible', 1)
            self.ren1_0.set_property('text', self.castel.find('locationx').text)
            self.ren1_1.set_property('text', self.castel.find('locationy').text)
            self.ren1_2.set_property('text', self.castel.find('locationz').text)
        elif value0 in self.stlnames:
            self.renToggle.set_property('visible', 0)
            self.ren1_0.set_property('visible', 1)
            self.ren1_1.set_property('visible', 1)
            self.ren1_2.set_property('visible', 0)
            self.ren1_0.set_property('text', self.surfaceLevel.find(value0).text)
            self.ren1_1.set_property('text', self.featureLevel.find(value0).text)
        elif value0[:7] == 'object-':
            self.renToggle.set_property('visible', 0)
            self.ren1_0.set_property('visible', 1)
            self.ren1_1.set_property('visible', 0)
            self.ren1_2.set_property('visible', 0)
            self.ren1_0.set_property('text', self.boxLevel.find(value0).text)
        elif value0 in entrys:
            self.renToggle.set_property('visible', 0)
            self.ren1_0.set_property('visible', 1)
            self.ren1_1.set_property('visible', 0)
            self.ren1_2.set_property('visible', 0)
            self.ren1_0.set_property('text', self.castel.find(value0).text)
        elif value0 == 'freeStandingZoneFaces':
            self.renToggle.set_property('visible', 1)
            self.ren1_0.set_property('visible', 0) 
            self.ren1_1.set_property('visible', 0) 
            self.ren1_2.set_property('visible', 0)                 
    #---------------------------------------------------------------------------------------------------------        
    def changeValue(self, widget, path, what, xyz):
    
        treeiter = self.treestore.get_iter(path)
        value0 = self.treestore.get_value(treeiter, 1)      

        if value0 == 'x y z coord.':
            if xyz == 'x':
                self.castel.find('locationx').text = what
            elif xyz == 'y':
                self.castel.find('locationy').text = what
            elif xyz == 'z':
                self.castel.find('locationz').text = what        
        elif value0 in self.stlnames:
            if xyz == 'x':
                self.surfaceLevel.find(value0).text = what
            elif xyz == 'y':
                self.featureLevel.find(value0).text = what
        elif value0[:7] == 'object-':
            self.boxLevel.find(value0).text = what
        else:
            self.castel.find(value0).text = what               
                
        generalClass(self).indentXML(self.root) 
        self.tree.write(self.caseDir + '/setup_snappy.xml')
    #---------------------------------------------------------------------------------------------------------
    def toggleRen(self, widget, path, model):
    
        model[path][2] = not model[path][2]       
        value0 = self.treestore[path][1]
        
        if model[path][2] == True:
            self.castel.find('allowFreeStanding').text = 'yes'
        else:
            self.castel.find('allowFreeStanding').text = 'no'

        self.treeview.expand_all()
    #---------------------------------------------------------------------------------------------------------             
    def selected(self, widget, treeview):
    
        self.selection = treeview.get_selection()
        tree_model, tree_iter = self.selection.get_selected()
        
        if tree_iter == None:
            return
                    
        path = tree_model.get_path(tree_iter)

        if path[1] == 1:
            if len(path) == 3:
                self.selectedPatch = tree_model.get_value(tree_iter, 1)
                self.highlightColor()
        elif path[1] == 2:
            self.selectedBox = tree_model.get_value(tree_iter, 1)
            self.highlightColorBox()
    #-----------------------------------------------------------------------------
    def highlightColor(self):   
     
        if self.selectedPatch != None:
            newind = self.stlnames.index(self.selectedPatch)                       
            for i in range(self.renderer.GetActors().GetNumberOfItems()):
                if i == newind:
                    self.renderer.GetActors().GetItemAsObject(i).GetProperty().SetColor(0, 0, 1)
                else: 
                    self.renderer.GetActors().GetItemAsObject(i).GetProperty().SetColor(1, 1, 1)          
            self.gvtk.Initialize()
    #-----------------------------------------------------------------------------
    def highlightColorBox(self):   
     
        if self.selectedBox != None:
            keys = self.boxActorDict.keys()
            for ii in keys:
                if ii == self.selectedBox:
                    self.boxActorDict[ii].GetProperty().SetColor(0, 0, 1)
                else:
                    self.boxActorDict[ii].GetProperty().SetColor(1, 1, 1)        
            self.gvtk.Initialize()
    #---------------------------------------------------------------------    
    def sizeLevelCalculator(self, widget):

        def calculate(widget):
            NN = float(levelcombo.child.get_text())
            sizex = size0x * (0.5**NN)
            sizey = size0y * (0.5**NN)
            sizez = size0z * (0.5**NN)
            resxEntry.set_text(str("%0.6f" %sizex))
            resyEntry.set_text(str("%0.6f" %sizey))
            reszEntry.set_text(str("%0.6f" %sizez))
        
        def closethis(widget):
            calwin.destroy()
                
        block = self.root.find('blockMesh')
        minx = block.find('minx').text
        miny = block.find('miny').text
        minz = block.find('minz').text
        maxx = block.find('maxx').text
        maxy = block.find('maxy').text
        maxz = block.find('maxz').text
        nodex = block.find('nx').text
        nodey = block.find('ny').text
        nodez = block.find('nz').text

        lengthx = float(maxx) - float(minx)
        lengthy = float(maxy) - float(miny)
        lengthz = float(maxz) - float(minz)
        size0x = lengthx / float(nodex)
        size0y = lengthy / float(nodey)
        size0z = lengthz / float(nodez)

        calwin = gtk.Window(gtk.WINDOW_TOPLEVEL)
        calwin.set_title('Size level calculator')
        calwin.set_border_width(10)
        calwin.set_position(gtk.WIN_POS_CENTER)
        calwin.set_transient_for(self.window)
            
        mainvbox = gtk.VBox(False,5)
        calwin.add(mainvbox)
        
        label = gtk.Label('Block Mesh Conditions')
        hbox = gtk.HBox(False,5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_start(label, False, False, 5)
        
        label = gtk.Label('Domain length, x / y / z')
        xlengEntry = gtk.Entry()
        xlengEntry.set_text(str(lengthx))
        xlengEntry.set_size_request(80, 28)
        ylengEntry = gtk.Entry()
        ylengEntry.set_text(str(lengthy))
        ylengEntry.set_size_request(80, 28)
        zlengEntry = gtk.Entry()
        zlengEntry.set_text(str(lengthz))
        zlengEntry.set_size_request(80, 28)
        hbox = gtk.HBox(False,5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_start(label, False, False, 5)
        hbox.pack_end(zlengEntry, False, False, 5)
        hbox.pack_end(ylengEntry, False, False, 0)
        hbox.pack_end(xlengEntry, False, False, 5)
        
        label = gtk.Label('Size of Level 0, x / y / z')
        xzeroEntry = gtk.Entry()
        xzeroEntry.set_text(str(size0x))
        xzeroEntry.set_size_request(80, 28)
        yzeroEntry = gtk.Entry()
        yzeroEntry.set_text(str(size0y))
        yzeroEntry.set_size_request(80, 28)
        zzeroEntry = gtk.Entry()
        zzeroEntry.set_text(str(size0z))
        zzeroEntry.set_size_request(80, 28)
        hbox = gtk.HBox(False, 5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_start(label, False, False, 5)
        hbox.pack_end(zzeroEntry, False, False, 5)
        hbox.pack_end(yzeroEntry, False, False, 0)
        hbox.pack_end(xzeroEntry, False, False, 5)
        
        separator = gtk.HSeparator()
        separator.set_size_request(285, 5)
        mainvbox.pack_start(separator, False, True, 5) 
        
        label = gtk.Label('Level to calculate')
        levelcombo=gtk.combo_box_entry_new_text()
        levelcombo.set_size_request(100, 28)
        for i in range(16):
            levelcombo.append_text(str(i))
        levelcombo.set_active(0)                              
        hbox = gtk.HBox(False,5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_start(label, False, False, 5)
        hbox.pack_end(levelcombo, False, False, 5)          
        
        calB = gtk.Button('Calculate')
        calB.set_size_request(150, 28)
        calB.connect('clicked', calculate)
        hbox = gtk.HBox(False,5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_end(calB, False, False, 5)
        
        separator = gtk.HSeparator()
        separator.set_size_request(285, 5)
        mainvbox.pack_start(separator, False, True, 5) 
        
        label = gtk.Label('Result, x / y /z')
        hbox = gtk.HBox(False,5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_start(label, False, False, 5)        

        resxEntry = gtk.Entry()
        resxEntry.set_size_request(100,28)
        resxEntry.set_text(str(size0x))
        resyEntry = gtk.Entry()
        resyEntry.set_size_request(100,28)
        resyEntry.set_text(str(size0y))
        reszEntry = gtk.Entry()
        reszEntry.set_size_request(100,28)
        reszEntry.set_text(str(size0z))
        hbox = gtk.HBox(False,5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_end(reszEntry, False, False, 5)
        hbox.pack_end(resyEntry, False, False, 5)
        hbox.pack_end(resxEntry, False, False, 5)

        separator = gtk.HSeparator()
        separator.set_size_request(285, 5)
        mainvbox.pack_start(separator, False, True, 5) 
                
        closeB = gtk.Button('Close')
        closeB.set_size_request(150, 28)
        closeB.connect('clicked', closethis)
        hbox = gtk.HBox(False,5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_end(closeB, False, False, 5)
        
        calwin.show_all()
    #---------------------------------------------------------------------    
    def showPoint(self, widget):
                
        if self.coneActor:
            self.renderer.RemoveActor(self.coneActor)
        
        xx = self.castel.find('locationx').text
        yy = self.castel.find('locationy').text
        zz = self.castel.find('locationz').text

        num = self.renderer.GetActors().GetNumberOfItems()                               
        for i in range(num):
            self.renderer.GetActors().GetItemAsObject(i).GetProperty().SetRepresentationToWireframe()
                
        scale = self.getLengthScale()
        self.coneActor = self.VTK_All.showPointSnappyNew(xx, yy, zz, scale)
        self.renderer.AddActor(self.coneActor)        
        self.gvtk.Initialize()        
        self.notebook.set_current_page(0)
    #-------------------------------------------------------------------------------------------------        
    def getLengthScale(self):

        stls = glob.glob(self.caseDir + '/constant/triSurface/*.stl')
        xranges = []
        yranges = []
        zranges = []
        for ii in stls:
            rangelist = self.GEN.getSTLRange(ii)
            xranges.append(rangelist[0][0])
            xranges.append(rangelist[1][0])
            yranges.append(rangelist[0][1])
            yranges.append(rangelist[1][1])
            zranges.append(rangelist[0][2])
            zranges.append(rangelist[1][2])
            
        minx = min(xranges)
        miny = min(yranges)
        minz = min(zranges)
        maxx = max(xranges)
        maxy = max(yranges)
        maxz = max(zranges) 
        
        dx = float(maxx) - float(minx)
        dy = float(maxy) - float(miny)
        dz = float(maxz) - float(minz)
        
        return max([dx, dy, dz])
    #---------------------------------------------------------------------------------------------------------            


