#-*-coding:utf8-*-

from common.fromAll_snappy  import *

class freepanelLayerClass:

    def __init__(self, mainself):
    
        self.caseDir = mainself.caseDir
        self.window = mainself.window
        self.installpath = mainself.installpath
        self.gvtk = mainself.gvtk
        self.notebook = mainself.notebook
        self.discombo = mainself.discombo
        
        self.root = mainself.root
        self.tree = mainself.tree
        self.stlnames = mainself.stlnames        
        self.layer = mainself.layer
        self.layerPatch = mainself.layerPatch

        self.GEN = generalClass(mainself)
        
        self.pixbuf_main = mainself.pixbuf_main
        self.pixbuf_first = mainself.pixbuf_first
        self.pixbuf_second = mainself.pixbuf_second
        
        self.renderer = mainself.renderer
        
    def addLayer(self):

        self.layerbox = gtk.VBox()          
        
        swin = gtk.ScrolledWindow()
        swin.set_border_width(0)
        swin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        swin.set_size_request(400, -1)
        
        self.underbox = gtk.VBox(False, 0)
        self.layerbox.pack_start(swin, True, True, 0)
        self.layerbox.pack_end(self.underbox, False, False, 0)
        
        ebox = gtk.EventBox()
        ebox.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('white'))
        swin.add_with_viewport(ebox)
        self.mainbox = gtk.VBox(False, 0)
        ebox.add(self.mainbox)
        
        self.getListStore()
        #-------------------------------------------------------------------------------------       
        self.treestore = gtk.TreeStore(gtk.gdk.Pixbuf, str, bool, str)
        
        self.treeview = gtk.TreeView(self.treestore)
        
        self.treeview.set_headers_visible(False)
        self.treeview.set_enable_tree_lines(True)

        self.treeview.connect('cursor-changed', self.selected, self.treeview)
                        
        self.tvcolumn0 = gtk.TreeViewColumn(None)
        self.tvcolumn1 = gtk.TreeViewColumn(None)
        
        self.treeview.append_column(self.tvcolumn0)
        self.treeview.append_column(self.tvcolumn1)

        self.renbuf = gtk.CellRendererPixbuf()
        self.ren0 = gtk.CellRendererText()
        self.renToggle = gtk.CellRendererToggle()                  
        self.ren1 = gtk.CellRendererCombo() 

        self.ren0.set_property('editable', False)
        self.renToggle.set_property('activatable', True)
        self.ren1.set_property('editable', True)
        self.ren1.set_property('text-column', 0)
        
        self.tvcolumn0.pack_start(self.renbuf, False)
        self.tvcolumn0.pack_start(self.ren0, False) 
        self.tvcolumn1.pack_start(self.renToggle, False)
        self.tvcolumn1.pack_start(self.ren1, False)
        
        self.tvcolumn0.set_attributes(self.renbuf, pixbuf = 0)
        self.tvcolumn0.set_attributes(self.ren0, text = 1)  
        self.tvcolumn1.add_attribute(self.renToggle, 'active', 2)
        
        self.renToggle.connect('toggled',self.toggleRen, self.treestore)
        self.ren1.connect('edited', self.changeValue)        
        self.tvcolumn1.set_cell_data_func(self.ren1, self.func)
        
        self.makeTreeStore()        
        self.mainbox.add(self.treeview)             
        # button     
        self.calB = gtk.Button('Layer height calculator')
        self.calB.set_size_request(150, 28)
        self.calB.connect('clicked', self.layerCalculator)
        
        hbox = gtk.HBox(False, 0)
        self.underbox.pack_start(hbox, False, False, 0)
        hbox.pack_start(self.calB, True, True, 0)

        return self.layerbox       
    #---------------------------------------------------------------------------------------------------------        
    def makeTreeStore(self):
    
        self.treestore.clear()
        
        row_patch = self.treestore.append(None, [self.pixbuf_main, 'Patch to add layer mesh', None, None])
        row_opt = self.treestore.append(None, [self.pixbuf_main, 'Options', None, None])
        row_adv = self.treestore.append(None, [self.pixbuf_main, 'Advanced', None, None])
        
        for ii in self.stlnames:
            if self.layerPatch.find(ii).text == 'yes':
                self.treestore.append(row_patch, [self.pixbuf_first, ii, True, None])
            else:
                self.treestore.append(row_patch, [self.pixbuf_first, ii, False, None])
            
        self.treestore.append(row_opt, [self.pixbuf_first, 'nlayer', None, None])
        self.treestore.append(row_opt, [self.pixbuf_first, 'expansionRatio', None, None])
        self.treestore.append(row_opt, [self.pixbuf_first, 'relativeSize', None, None])
        self.treestore.append(row_opt, [self.pixbuf_first, 'thicknessMethod', None, None])
        if self.layer.find('thicknessMethod').text == 'finalLayer':
            self.treestore.append(row_opt, [self.pixbuf_first, 'finalThickness', None, None])
        if self.layer.find('thicknessMethod').text == 'firstLayer':
            self.treestore.append(row_opt, [self.pixbuf_first, 'firstThickness', None, None])
        if self.layer.find('thicknessMethod').text == 'overall':        
            self.treestore.append(row_opt, [self.pixbuf_first, 'overallThickness', None, None])
        self.treestore.append(row_opt, [self.pixbuf_first, 'minThickness', None, None])
        self.treestore.append(row_opt, [self.pixbuf_first, 'nGrow', None, None])
        
        self.treestore.append(row_adv, [self.pixbuf_first, 'featureAngle', None, None])
        self.treestore.append(row_adv, [self.pixbuf_first, 'slipFeatureAngle', None, None])
        self.treestore.append(row_adv, [self.pixbuf_first, 'nRelaxIter', None, None])
        self.treestore.append(row_adv, [self.pixbuf_first, 'nSmoothSurfaceNormals', None, None])
        self.treestore.append(row_adv, [self.pixbuf_first, 'nSmoothNormals', None, None])
        self.treestore.append(row_adv, [self.pixbuf_first, 'nSmoothThickness', None, None])
        self.treestore.append(row_adv, [self.pixbuf_first, 'maxFaceThicknessRatio', None, None])
        self.treestore.append(row_adv, [self.pixbuf_first, 'maxThicknessToMedialRatio', None, None])
        self.treestore.append(row_adv, [self.pixbuf_first, 'minMedianAxisAngle', None, None])
        self.treestore.append(row_adv, [self.pixbuf_first, 'nBufferCellsNoExtrude', None, None])
        self.treestore.append(row_adv, [self.pixbuf_first, 'nLayerIter', None, None])
        self.treestore.append(row_adv, [self.pixbuf_first, 'nRelaxedIter', None, None])

        self.treeview.expand_all()         
    #---------------------------------------------------------------------------------------------    
    def func(self, column, cell, model, iter):

        value0 = model.get_value(iter, 1)
        path = model.get_path(iter)
        
        noneList = ['Patch to add layer mesh', 'Options', 'Advanced']
        comboList = ['relativeSize', 'thicknessMethod']       
        
        if value0 in noneList:
            self.renToggle.set_property('visible', 0)
            self.ren1.set_property('visible' ,0)
        elif value0 in self.stlnames:
            self.renToggle.set_property('visible', 1)
            self.ren1.set_property('visible', 0) 
        elif value0 in comboList:                       
            self.renToggle.set_property('visible', 0)
            self.ren1.set_property('visible', 1)                        
            self.ren1.set_property('has-entry', False)
            self.ren1.set_property('text', self.layer.find(value0).text)
            if value0 == 'relativeSize': 
                self.ren1.set_property('model', self.liststore_relative)               
            elif value0 == 'thicknessMethod': 
                self.ren1.set_property('model', self.liststore_thickness)
        else:
            self.renToggle.set_property('visible', 0)
            self.ren1.set_property('visible', 1)            
            self.ren1.set_property('model', None)
            self.ren1.set_property('has-entry', True)
            self.ren1.set_property('text', self.layer.find(value0).text) 
    #---------------------------------------------------------------------------------------------------------
    def toggleRen(self, widget, path, model):
    
        model[path][2] = not model[path][2]       
        value0 = self.treestore[path][1]
       
        if model[path][2] == True:
            self.layerPatch.find(value0).text = 'yes'
        else:
            self.layerPatch.find(value0).text = 'no'

        generalClass(self).indentXML(self.root) 
        self.tree.write(self.caseDir + '/setup_snappy.xml')
    #---------------------------------------------------------------------------------------------------------        
    def changeValue(self, widget, path, what):
    
        treeiter = self.treestore.get_iter(path)
        value0 = self.treestore.get_value(treeiter, 1)        

        self.layer.find(value0).text = what
        
        self.makeTreeStore()

        generalClass(self).indentXML(self.root) 
        self.tree.write(self.caseDir + '/setup_snappy.xml')      
    #---------------------------------------------------------------------------------------------------------             
    def selected(self, widget, treeview):
    
        self.selection = treeview.get_selection()
        tree_model, tree_iter = self.selection.get_selected()
        
        if tree_iter == None:
            return
                    
        path = tree_model.get_path(tree_iter)

        if path[0] == 0:
            if len(path) == 2:
                self.selectedPatch = tree_model.get_value(tree_iter, 1)
                self.highlightColor()
    #-----------------------------------------------------------------------------
    def highlightColor(self):   
     
        if self.selectedPatch != None:
            newind = self.stlnames.index(self.selectedPatch)                       
            for i in range(self.renderer.GetActors().GetNumberOfItems()):
                if i == newind:
                    self.renderer.GetActors().GetItemAsObject(i).GetProperty().SetColor(0, 0, 1)
                else: 
                    self.renderer.GetActors().GetItemAsObject(i).GetProperty().SetColor(1, 1, 1)          
            self.gvtk.Initialize()
    #---------------------------------------------------------------------------------------------
    def getListStore(self):

        yesno = ['yes', 'no']
        thickList = ['firstLayer', 'finalLayer', 'overall']  
        
        self.liststore_relative = gtk.ListStore(str)
        for ii in yesno:
            self.liststore_relative.append([ii])
        
        self.liststore_thickness = gtk.ListStore(str)
        for ii in thickList:
            self.liststore_thickness.append([ii])
    #---------------------------------------------------------------------
    def layerCalculator(self, widget):

        def calculate(widget):
            nn = float(nEntry.get_text())
            first = float(firstEntry.get_text())
            ratio = float(expanEntry.get_text())
            last = first * ratio**(nn - 1)
            
            overall = 0.
            for i in range(int(nEntry.get_text())):
                overall = overall + first * ratio**(i)

            lastEntry.set_text(str("%0.6f" %last))
            overEntry.set_text(str("%0.6f" %overall))
        
        def closethis(widget):
            calwin.destroy()

        calwin = gtk.Window(gtk.WINDOW_TOPLEVEL)
        calwin.set_title('Layer size calculator')
        calwin.set_border_width(10)
        calwin.set_position(gtk.WIN_POS_CENTER)
        calwin.set_transient_for(self.window)
            
        mainvbox = gtk.VBox(False, 5)
        calwin.add(mainvbox)
        
        label = gtk.Label('Conditions')
        hbox = gtk.HBox(False, 5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_start(label, False, False, 5)
        
        label = gtk.Label('No. of layers      ')
        nEntry = gtk.Entry()
        nEntry.set_text('3')
        nEntry.set_size_request(80, 28)
        hbox = gtk.HBox(False, 5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_end(nEntry, False, False, 5)
        hbox.pack_end(label, False, False, 5)
        
        label = gtk.Label('First cell height')
        firstEntry = gtk.Entry()
        firstEntry.set_text('0.001')
        firstEntry.set_size_request(80, 28)
        hbox = gtk.HBox(False, 5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_end(firstEntry, False, False, 5)
        hbox.pack_end(label, False, False, 5)
                
        label = gtk.Label('Expansion ratio')
        expanEntry = gtk.Entry()
        expanEntry.set_text('1.0')
        expanEntry.set_size_request(80, 28)
        hbox = gtk.HBox(False, 5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_end(expanEntry, False, False, 5)
        hbox.pack_end(label, False, False, 5)
       
        calB = gtk.Button('Calculate')
        calB.set_size_request(150, 28)
        calB.connect('clicked', calculate)
        hbox = gtk.HBox(False, 5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_end(calB, False, False, 5)
        
        separator = gtk.HSeparator()
        separator.set_size_request(285, 5)
        mainvbox.pack_start(separator, False, True, 5) 
        
        label = gtk.Label('Result')
        hbox = gtk.HBox(False, 5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_start(label, False, False, 5)        
        
        label = gtk.Label('Last cell height')
        lastEntry = gtk.Entry()
        lastEntry.set_size_request(100, 28)
        hbox = gtk.HBox(False, 5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_end(lastEntry, False, False, 5)
        hbox.pack_start(label, False, False, 5)
        
        label = gtk.Label('Overall layer thickness')
        overEntry = gtk.Entry()
        overEntry.set_size_request(100, 28)
        hbox = gtk.HBox(False, 5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_end(overEntry, False, False, 5)
        hbox.pack_start(label, False, False, 5)

        separator = gtk.HSeparator()
        separator.set_size_request(285, 5)
        mainvbox.pack_start(separator, False, True, 5) 
                
        closeB = gtk.Button('Close')
        closeB.set_size_request(150, 28)
        closeB.connect('clicked', closethis)
        hbox = gtk.HBox(False, 5)
        mainvbox.pack_start(hbox, False, False, 5)
        hbox.pack_end(closeB, False, False, 5)
        
        
        calwin.show_all()
         
                                    

