#-*-coding:utf8-*-

from common.fromAll_snappy  import *
from snappyHexMesh        import *

class freepanelRunSnappyClass:

    def __init__(self, mainself):

        self.caseDir = mainself.caseDir
        self.mainwindow = mainself.window
        self.installpath = mainself.installpath
        self.notebook = mainself.notebook
        
        self.root = mainself.root
        self.tree = mainself.tree
        self.run = self.root.find('runConditions')
        self.stlnames = mainself.stlnames
        self.mainself = mainself

        self.GEN = generalClass(mainself)
        
        self.pixbuf_main = mainself.pixbuf_main
        self.pixbuf_first = mainself.pixbuf_first
        self.pixbuf_second = mainself.pixbuf_second
                
    def runSnappy(self):       

        self.runbox = gtk.VBox()          
        
        swin = gtk.ScrolledWindow()
        swin.set_border_width(0)
        swin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        swin.set_size_request(400, -1)

        self.underbox = gtk.VBox(False, 0)        
        self.runbox.pack_start(swin, True, True, 0)
        self.runbox.pack_end(self.underbox, False, False, 0)
                
        ebox = gtk.EventBox()
        ebox.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('white'))
        swin.add_with_viewport(ebox)
        self.mainbox = gtk.VBox(False, 0)
        ebox.add(self.mainbox)
        
        self.getListStore()
        #-------------------------------------------------------------------------------------       
        self.treestore = gtk.TreeStore(gtk.gdk.Pixbuf, str, bool, str)
        
        self.treeview = gtk.TreeView(self.treestore)
        
        self.treeview.set_headers_visible(False)
        self.treeview.set_enable_tree_lines(True)
                
        self.tvcolumn0 = gtk.TreeViewColumn(None)
        self.tvcolumn1 = gtk.TreeViewColumn(None)
        
        self.treeview.append_column(self.tvcolumn0)
        self.treeview.append_column(self.tvcolumn1)

        self.renbuf = gtk.CellRendererPixbuf()
        self.ren0 = gtk.CellRendererText()
        self.renToggle = gtk.CellRendererToggle()                  
        self.ren1 = gtk.CellRendererCombo() 

        self.ren0.set_property('editable', False)
        self.renToggle.set_property('activatable', True)
        self.ren1.set_property('editable', True)
        self.ren1.set_property('text-column', 0)
        
        self.ren0.set_fixed_size(170, -1) 
        
        self.tvcolumn0.pack_start(self.renbuf, False)
        self.tvcolumn0.pack_start(self.ren0, False) 
        self.tvcolumn1.pack_start(self.renToggle, False)
        self.tvcolumn1.pack_start(self.ren1, False)
        
        self.tvcolumn0.set_attributes(self.renbuf, pixbuf = 0)
        self.tvcolumn0.set_attributes(self.ren0, text = 1)  
        self.tvcolumn1.add_attribute(self.renToggle, 'active', 2)
        
        self.renToggle.connect('toggled',self.toggleRen, self.treestore)
        self.ren1.connect('edited', self.changeValue)        
        self.tvcolumn1.set_cell_data_func(self.ren1, self.func)
        
        self.makeTreeStore()        
        self.mainbox.add(self.treeview)             
        # button     
        self.initialB = gtk.Button('Initialize')
        self.initialB.set_size_request(150, 28)
        self.initialB.connect('clicked', self.resetMesh)
        
        self.runB = gtk.Button('Start Run')
        self.runB.set_size_request(150, 28)
        self.runB.connect('clicked', self.applyRun)
        
        hbox = gtk.HBox(False, 0)
        self.underbox.pack_start(hbox, False, False, 0)
        hbox.pack_start(self.initialB, True, True, 0)
        hbox.pack_start(self.runB, True, True, 0)
        
        return self.runbox
    #---------------------------------------------------------------------------------------------------------        
    def makeTreeStore(self):
    
        self.treestore.clear()
        
        row_stage = self.treestore.append(None, [self.pixbuf_main, 'Run mode', None, None])
        row_opt = self.treestore.append(None, [self.pixbuf_main, 'Options', None, None])
        row_par = self.treestore.append(None, [self.pixbuf_main, 'Parallel options', None, None])
       
        if self.run.find('castellate').text == 'yes':
            self.treestore.append(row_stage, [self.pixbuf_first, 'castellate', True, None])
        else:
            self.treestore.append(row_stage, [self.pixbuf_first, 'castellate', False, None])
        if self.run.find('snap').text == 'yes':
            self.treestore.append(row_stage, [self.pixbuf_first, 'snap', True, None])
        else:
            self.treestore.append(row_stage, [self.pixbuf_first, 'snap', False, None])
        if self.run.find('addLayer').text == 'yes':
            self.treestore.append(row_stage, [self.pixbuf_first, 'addLayer', True, None])
        else:
            self.treestore.append(row_stage, [self.pixbuf_first, 'addLayer', False, None])
        
        self.treestore.append(row_opt, [self.pixbuf_first, 'writePrecision', None, None])
        self.treestore.append(row_opt, [self.pixbuf_first, 'writeFormat', None, None])
        if self.run.find('dataCompression').text == 'yes':
            self.treestore.append(row_opt, [self.pixbuf_first, 'dataCompression', True, None])
        else:
            self.treestore.append(row_opt, [self.pixbuf_first, 'dataCompression', False, None])
            
        self.treestore.append(row_par, [self.pixbuf_first, 'nCores', None, None])
        self.treestore.append(row_par, [self.pixbuf_first, 'parallelType', None, None])

        self.treeview.expand_all()         
    #---------------------------------------------------------------------------------------------    
    def func(self, column, cell, model, iter):

        value0 = model.get_value(iter, 1)
        path = model.get_path(iter)
        
        noneList = ['Run mode', 'Options', 'Parallel options']
        entryList = ['writePrecision', 'nCores']
        checkList = ['castellate', 'snap', 'addLayer', 'overwrite', 'dataCompression']       
        comboList = ['writeFormat', 'parallelType', 'startFrom']
        
        if value0 in noneList:
            self.renToggle.set_property('visible', 0)
            self.ren1.set_property('visible' ,0)

        elif value0 in entryList:
            self.renToggle.set_property('visible', 0)
            self.ren1.set_property('visible', 1)            
            self.ren1.set_property('model', None)
            self.ren1.set_property('has-entry', True)
            self.ren1.set_property('text', self.run.find(value0).text)                      

        elif value0 in comboList:
            self.renToggle.set_property('visible', 0)
            self.ren1.set_property('visible', 1)            
            self.ren1.set_property('has-entry', False)
            self.ren1.set_property('text', self.run.find(value0).text)
            if value0 == 'writeFormat':
                self.ren1.set_property('model', self.liststore_writeFormat)
            elif value0 == 'parallelType':
                self.ren1.set_property('model', self.liststore_parallelType)
            elif value0 == 'startFrom':
                self.ren1.set_property('model', self.liststore_startFrom)             
            
        elif value0 in checkList:
            self.renToggle.set_property('visible', 1)
            self.ren1.set_property('visible', 0) 
    #---------------------------------------------------------------------------------------------------------
    def toggleRen(self, widget, path, model):
    
        model[path][2] = not model[path][2]       
        value0 = self.treestore[path][1]
       
        if model[path][2] == True:
            self.run.find(value0).text = 'yes'
        else:
            self.run.find(value0).text = 'no'
        self.treeview.expand_all()

        generalClass(self).indentXML(self.root) 
        self.tree.write(self.caseDir + '/setup_snappy.xml')
    #---------------------------------------------------------------------------------------------------------        
    def changeValue(self, widget, path, what):
    
        treeiter = self.treestore.get_iter(path)
        value0 = self.treestore.get_value(treeiter, 1)        

        self.run.find(value0).text = what
        if value0 == 'parallelType':
            if self.run.find('nCores').text == '1':
                self.GEN.makeDialog('Warning!!! nCores is 1')
                return
            else:
                self.selhostfile(path)            

        generalClass(self).indentXML(self.root) 
        self.tree.write(self.caseDir + '/setup_snappy.xml')  
    #---------------------------------------------------------------------------------------------
    def getListStore(self):

        writeFormat = ['ascii', 'binary']
        parallelType = ['SMP', 'Cluster']
        startFrom = ['0', '1', '2']  
        
        self.liststore_writeFormat = gtk.ListStore(str)
        for ii in writeFormat:
            self.liststore_writeFormat.append([ii])
        
        self.liststore_parallelType = gtk.ListStore(str)
        for ii in parallelType:
            self.liststore_parallelType.append([ii])
            
        self.liststore_startFrom = gtk.ListStore(str)
        for ii in startFrom:
            self.liststore_startFrom.append([ii])  
    #------------------------------------------------------------------------
    def applyRun(self, widget):
    
        if self.GEN.isSolverRunningSnappy():
            self.GEN.makeDialog('SnappyHexMesh is Running')
            return
    
        RUN = snappyHexMeshRunClass(self.caseDir, self.installpath, self.mainself.termTTY)            
        RUN.runSnappyHex(self.root, self.stlnames, self.notebook)        
    #------------------------------------------------------------------------
    def resetMesh(self, widget):
    
        if self.GEN.isSolverRunningSnappy():
            self.GEN.makeDialog('SnappyHexMesh is Running')
            return
    
        results=self.GEN.getResult()
        serialResult = results[0]
        parallelResult = results[1]
        
        aa = glob.glob(self.caseDir + '/Running')
        if aa:
            os.system('rm ' + self.caseDir + '/Running')
        
        aa = glob.glob(self.caseDir + '/processor*')
        if aa:
            os.system('rm -r ' + self.caseDir + '/processor*')
        
        for kk in serialResult:
            os.system('rm -r ' + self.caseDir + '/' + kk)
        
        aa = glob.glob(self.caseDir + '/constant/polyMesh/*')
        for ii in aa:
            if ii != self.caseDir + '/constant/polyMesh/blockMeshDict':
                os.system('rm -r ' + ii)

        self.GEN.submitFile('blockMesh -case ' + self.caseDir + ' > /dev/null 2>&1')   
    #------------------------------------------------------------------------
    def selhostfile(self, path):
    
        partype = self.run.find('parallelType').text
        if partype == 'Cluster':        
            dialog = gtk.FileChooserDialog("Open..", None,gtk.FILE_CHOOSER_ACTION_OPEN, 
                     (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OPEN, gtk.RESPONSE_OK))
            dialog.set_default_response(gtk.RESPONSE_OK)
            response = dialog.run()
            if response == gtk.RESPONSE_OK:
                hostfilename = dialog.get_filename()
            elif response == gtk.RESPONSE_CANCEL:
                hostfilename = 'None'
            dialog.destroy()       
        else:
            hostfilename = 'None'
            
        self.run.find('hostFile').text = hostfilename

        if hostfilename == 'None':
            self.treestore[path][3] = 'SMP'
            self.run.find('parallelType').text = 'SMP'            
        else:
            self.run.find('parallelType').text = 'Cluster'
            os.system('cp ' + hostfilename + ' ' + self.caseDir + '/hostfile') 
                                
        self.makeTreeStore()
    #------------------------------------------------------------------------

  
    
    


