#-*-coding:utf8-*-

from common.fromAll_snappy  import *

class freepanelSnapClass:

    def __init__(self, mainself):
        self.caseDir = mainself.caseDir
        self.mainwindow = mainself.window
        self.installpath = mainself.installpath
        self.gvtk = mainself.gvtk
        self.notebook = mainself.notebook
        self.discombo = mainself.discombo
        
        self.root = mainself.root
        self.tree = mainself.tree
        self.stlnames = mainself.stlnames        
        self.snap = self.root.find('snap')

        self.GEN = generalClass(mainself)
        
        self.pixbuf_main = mainself.pixbuf_main
        self.pixbuf_first = mainself.pixbuf_first
        self.pixbuf_second = mainself.pixbuf_second
        
    def snapPanel(self):

        self.snapbox = gtk.VBox()          
        
        swin = gtk.ScrolledWindow()
        swin.set_border_width(0)
        swin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        swin.set_size_request(400, -1)
        
        self.snapbox.pack_start(swin, True, True, 0)
        
        ebox = gtk.EventBox()
        ebox.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('white'))
        swin.add_with_viewport(ebox)
        self.mainbox = gtk.VBox(False, 0)
        ebox.add(self.mainbox)
        #-------------------------------------------------------------------------------------       
        self.treestore = gtk.TreeStore(gtk.gdk.Pixbuf, str, bool, str)
        
        self.treeview = gtk.TreeView(self.treestore)
        
        self.treeview.set_headers_visible(False)
        self.treeview.set_enable_tree_lines(True)
                
        self.tvcolumn0 = gtk.TreeViewColumn(None)
        self.tvcolumn1 = gtk.TreeViewColumn(None)
        
        self.treeview.append_column(self.tvcolumn0)
        self.treeview.append_column(self.tvcolumn1)

        self.renbuf = gtk.CellRendererPixbuf()
        self.ren0 = gtk.CellRendererText()
        self.renToggle = gtk.CellRendererToggle()                  
        self.ren1 = gtk.CellRendererCombo() 

        self.ren0.set_property('editable', False)
        self.renToggle.set_property('activatable', True)
        self.ren1.set_property('editable', True)
        self.ren1.set_property('text-column', 0)
        
        self.ren0.set_fixed_size(170, -1) 
        
        self.tvcolumn0.pack_start(self.renbuf, False)
        self.tvcolumn0.pack_start(self.ren0, False) 
        self.tvcolumn1.pack_start(self.renToggle, False)
        self.tvcolumn1.pack_start(self.ren1, False)
        
        self.tvcolumn0.set_attributes(self.renbuf, pixbuf = 0)
        self.tvcolumn0.set_attributes(self.ren0, text = 1)  
        self.tvcolumn1.add_attribute(self.renToggle, 'active', 2)
        
        self.renToggle.connect('toggled',self.toggleRen, self.treestore)
        self.ren1.connect('edited', self.changeValue)        
        self.tvcolumn1.set_cell_data_func(self.ren1, self.func)
        
        self.makeTreeStore()        
        self.mainbox.add(self.treeview)             

        return self.snapbox
    #---------------------------------------------------------------------------------------------------------        
    def makeTreeStore(self):
    
        self.treestore.clear()
        
        row_main = self.treestore.append(None, [self.pixbuf_main, 'Snap mesh', None, None])
       
        self.treestore.append(row_main, [self.pixbuf_first, 'nSmoothPatch', None, None])
        self.treestore.append(row_main, [self.pixbuf_first, 'tolerance', None, None])
        self.treestore.append(row_main, [self.pixbuf_first, 'nSolveIter', None, None])
        self.treestore.append(row_main, [self.pixbuf_first, 'nRelaxIter', None, None])
        self.treestore.append(row_main, [self.pixbuf_first, 'nFeatureSnapIter', None, None])
        if self.snap.find('implicitFeatureSnap').text == 'yes':
            self.treestore.append(row_main, [self.pixbuf_first, 'implicitFeatureSnap', True, None])
        else:
            self.treestore.append(row_main, [self.pixbuf_first, 'implicitFeatureSnap', False, None])
        if self.snap.find('explicitFeatureSnap').text == 'yes':
            self.treestore.append(row_main, [self.pixbuf_first, 'explicitFeatureSnap', True, None])
        else:
            self.treestore.append(row_main, [self.pixbuf_first, 'explicitFeatureSnap', False, None])
        if self.snap.find('multiRegionFeatureSnap').text == 'yes':
            self.treestore.append(row_main, [self.pixbuf_first, 'multiRegionFeatureSnap', True, None])
        else:
            self.treestore.append(row_main, [self.pixbuf_first, 'multiRegionFeatureSnap', False, None])

        self.treeview.expand_all()         
    #---------------------------------------------------------------------------------------------    
    def func(self, column, cell, model, iter):

        value0 = model.get_value(iter, 1)
        path = model.get_path(iter)
        
        entryList = ['nSmoothPatch', 'tolerance', 'nSolveIter', 'nRelaxIter', 'nFeatureSnapIter']
        checkList = ['implicitFeatureSnap', 'explicitFeatureSnap', 'multiRegionFeatureSnap']       
        
        if value0 == 'Snap mesh':
            self.renToggle.set_property('visible', 0)
            self.ren1.set_property('visible' ,0)

        elif value0 in entryList:
            self.renToggle.set_property('visible', 0)
            self.ren1.set_property('visible', 1)            
            self.ren1.set_property('model', None)
            self.ren1.set_property('has-entry', True)
            self.ren1.set_property('text', self.snap.find(value0).text)                      
        elif value0 in checkList:
            self.renToggle.set_property('visible', 1)
            self.ren1.set_property('visible', 0) 
    #---------------------------------------------------------------------------------------------------------
    def toggleRen(self, widget, path, model):
    
        model[path][2] = not model[path][2]       
        value0 = self.treestore[path][1]
       
        if model[path][2] == True:
            self.snap.find(value0).text = 'yes'
        else:
            self.snap.find(value0).text = 'no'
        self.treeview.expand_all()

        generalClass(self).indentXML(self.root)
        self.tree.write(self.caseDir + '/setup_snappy.xml')
    #---------------------------------------------------------------------------------------------------------        
    def changeValue(self, widget, path, what):
    
        treeiter = self.treestore.get_iter(path)
        value0 = self.treestore.get_value(treeiter, 1)        

        if self.GEN.checkNumber(value0, what):
            self.snap.find(value0).text = what

        generalClass(self).indentXML(self.root) 
        self.tree.write(self.caseDir + '/setup_snappy.xml')     
        



        
