#-*-coding:utf8-*-

from common.fromAll_snappy  import *
from writeFileSnappy      import *

class snappyHexMeshRunClass:

    def __init__(self, caseDir, installpath, termTTY):
    
        self.caseDir = caseDir
        self.installpath = installpath
        self.termTTY = termTTY
                
    def runSnappyHex(self, root, stlnames, notebook):
        
        castellate = root.find('castellate')
        featureLevel = castellate.find('featureLevel')
        
        cad = root.find('cad')
        featureAngle = cad.find('featureAngle').text
        nonManifoldEdges = cad.find('nonManifoldEdges').text
        openEdges = cad.find('openEdges').text
        
        run = root.find('runConditions')
        nCores = run.find('nCores').text

        WFILE = writeFileClassSnappy(self.caseDir)
        WFILE.decomposeParDict(nCores)
        WFILE.controlDictFile(run)
        WFILE.makeFeatureFile(stlnames, featureAngle, nonManifoldEdges, openEdges)
        WFILE.createPatchNone()
            
        WFILE.snappyHexMeshDict(root)
        generalClass(self).submitFile('surfaceFeatureExtract -case ' + self.caseDir + ' > /dev/null 2>&1')
            
        startFrom = run.find('startFrom').text
        nCores = run.find('nCores').text
        parallelType = run.find('parallelType').text
        overwrite = run.find('overwrite').text            
                                
        self.snappyHexMeshRun(startFrom, nCores, parallelType, overwrite, notebook)
    #----------------------------------------------------------------------------------
    def snappyHexMeshRun(self, startFrom, nCores, smpOrCluster, overwrite, notebook):

        GEN = generalClass(self)
        a1 = glob.glob(self.caseDir + '/1')
        a2 = glob.glob(self.caseDir + '/2')
        a3 = glob.glob(self.caseDir + '/3')
        
        if startFrom == '0':
            if a1 != []:
                os.system('rm -r ' + a1[0])
            if a2 != []:
                os.system('rm -r ' + a2[0])
            if a3 != []:
                os.system('rm -r ' + a3[0])                                    
        elif startFrom == '1':
            if a2 != []:
                os.system('rm -r ' + a2[0])
            if a3 != []:
                os.system('rm -r ' + a3[0])            
            if a1 == []:
                GEN.makeDialog('Error!!! There is not "1" folder')            
        elif startFrom == '2':
            if a3 != []:
                os.system('rm -r ' + a3[0])
            if a2 == []:
                GEN.makeDialog('Error!!! There is not "2" folder')
        
        notebook.set_current_page(1) 
        
        rf = open(self.caseDir + '/runSolver', 'w')

        if nCores == '1':#serial
            aa = glob.glob(self.caseDir + '/processor*')
            if aa:
                rf.write('rm -r ' + self.caseDir + '/processor*\n')
                
            if overwrite == 'false':
                rf.write('snappyHexMesh -case ' + self.caseDir + '\n')
            else:
                rf.write('snappyHexMesh -overwrite -case ' + self.caseDir + '\n')

        else:#parallel
            rf.write('decomposePar -force -case ' + self.caseDir + '\n')
            if smpOrCluster == 'SMP':
                if overwrite == 'false':
                    rf.write('mpirun -np ' + nCores + ' snappyHexMesh -case ' + self.caseDir + ' -parallel \n')
                else:
                    rf.write('mpirun -np ' + nCores + ' snappyHexMesh -overwrite -case ' + self.caseDir + ' -parallel \n')
            else:
                if overwrite == 'false':
                    rf.write('mpirun --hostfile hostfile' + ' -np '+ nCores +' snappyHexMesh -case ' + self.caseDir + ' -parallel \n')
                else:
                    rf.write('mpirun --hostfile hostfile' + ' -np '+ nCores +' snappyHexMesh -overwrite -case ' + self.caseDir + ' -parallel \n')
            rf.write('reconstructParMesh -case ' + self.caseDir + ' -constant -mergeTol 1e-06\n')

        rf.write('createPatch -overwrite -case ' + self.caseDir + '\n')        
        rf.write('foamToVTK -constant -noInternal -noZero -case ' + self.caseDir + '\n')
        rf.close()
        os.system('chmod +x ' + self.caseDir + '/runSolver')
        
        logDir = self.caseDir + '/logfiles'        
        os.system(self.caseDir + '/runSolver > /dev/pts/' + self.termTTY + '& \n echo $! > ' + self.caseDir + '/logfiles/runSnappyPID')






         

  


